--[[
	Thank you for trying out 'Wan-Wan!' (Bow-Wow!)!
	
	Feel free to let me know of any bugs or other errors via comments on the
	Curse website (where you would have obtained this AddOn). Please make
	sure you post the whole error message. I will get it fixed as soon as I can.
	
	Regards,
	Cammy Bear.
]]

function WanWan_OnLoad(self)
	self.BattleCount = nil;
	self.Count = nil;
	self.IsBattleReady = true;
	self.IsReady = true;

	self.Defaults = {
		Count_Max = 5,
		Enabled = true,
		Spam = true,
		Version = 3.2,
	};

	self.Options = {};

	self.CurrentVersion = 3.2;

	self.UpdateInterval = 1.0;
	self.TimeSinceLastUpdate = 0;

	self:RegisterForDrag("LeftButton,RightButton");

	self:RegisterEvent("ADDON_LOADED");
	self:RegisterEvent("PLAYER_LOGOUT");
	self:RegisterEvent("GLYPH_UPDATED");

	self:RegisterEvent("PLAYER_ENTER_COMBAT");
	self:RegisterEvent("PLAYER_REGEN_ENABLED");

	self:RegisterEvent("AUCTION_HOUSE_SHOW");
	self:RegisterEvent("BANKFRAME_OPENED");
	self:RegisterEvent("BATTLEFIELDS_SHOW");
	self:RegisterEvent("FORGE_MASTER_OPENED");
	self:RegisterEvent("GOSSIP_SHOW");
	self:RegisterEvent("LFG_OPEN_FROM_GOSSIP");
	self:RegisterEvent("MERCHANT_SHOW");
	self:RegisterEvent("QUEST_GREETING");
	self:RegisterEvent("TAXIMAP_OPENED");
	self:RegisterEvent("TRAINER_SHOW");

	self.Events = {
		"AUCTION_HOUSE_SHOW",
		"BANKFRAME_OPENED",
		"BATTLEFIELDS_SHOW",
		"FORGE_MASTER_OPENED",
		"GOSSIP_SHOW",
		"LFG_OPEN_FROM_GOSSIP",
		"MERCHANT_SHOW",
		"QUEST_GREETING",
		"TAXIMAP_OPENED",
		"TRAINER_SHOW",
	};

	SlashCmdList["WANWAN_MENU"] = WanWan_Menu;
	SLASH_WANWAN_MENU1 = "/wanwan";
	SLAHS_WANWAN_MENU2 = "/bowwow";

	WanWan_Sounds = {
		["Aquatic Form"] = {
			[1] = "Sound\\Creature\\Walrus\\WalrusAttackA.ogg",
			[2] = "Sound\\Creature\\Walrus\\WalrusAttackB.ogg",
			[3] = "Sound\\Creature\\Walrus\\WalrusAttackC.ogg",
			[4] = "Sound\\Creature\\Walrus\\WalrusPreAggro.ogg",
			["Aggro"] = "Sound\\Creature\\Walrus\\WalrusAggroA.ogg",
		},
		["Bat Form"] = {
			[1] = "Sound\\Creature\\Felbat\\FelBatAttackA.ogg",
			[2] = "Sound\\Creature\\Felbat\\FelBatAttackB.ogg",
			[3] = "Sound\\Creature\\Felbat\\FelBatAttackC.ogg",
			[4] = "Sound\\Creature\\Felbat\\FelBatPreaggro.ogg",
		},
		["Bear Form"] = {
			[1] = "Sound\\Creature\\Bear\\mBearAttackA.ogg",
			[2] = "Sound\\Creature\\Bear\\mBearAttackB.ogg",
			[3] = "Sound\\Creature\\Bear\\mBearAttackD.ogg",
			[4] = "Sound\\Creature\\Bear\\mBearAttackCriticalA.ogg",
			["Aggro"] = "Sound\\Creature\\Bear\\mBearAggroA.ogg",
		},
		["Cat Form"] = {
			[1] = "Sound\\Creature\\Tiger\\mTigerAttackA.ogg",
			[2] = "Sound\\Creature\\Tiger\\mTigerAttackB.ogg",
			[3] = "Sound\\Creature\\Tiger\\mTigerAttackC.ogg",
			[4] = "Sound\\Creature\\Tiger\\mTigerAttackD.ogg",
			["Aggro"] = "Sound\\Creature\\Tiger\\mTigerDeathA.ogg",
		},
		["Flight Form"] = {
			[1] = "Sound\\Creature\\StormCrow\\StormCrowAttackA.ogg",
			[2] = "Sound\\Creature\\StormCrow\\StormCrowAttackB.ogg",
			[3] = "Sound\\Creature\\StormCrow\\StormCrowAttackC.ogg",
			[4] = "Sound\\Creature\\StormCrow\\StormCrowPreAggro.ogg",
		},
		["Ghost Wolf"] = {
			[1] = "Sound\\Creature\\Wolf\\mWolfAttack1.ogg",
			[2] = "Sound\\Creature\\Wolf\\mWolfAttack2.ogg",
			[3] = "Sound\\Creature\\Wolf\\mWolfAttack3.ogg",
			[4] = "Sound\\Creature\\Wolf\\mWolfAttack4.ogg",
			[5] = "Sound\\Creature\\Wolf\\mWolfAttack5.ogg",
			[6] = "Sound\\Creature\\Wolf\\mWolfAttack6.ogg",
			["Aggro"] = "Sound\\Creature\\Wolf\\mWolfAggro3.ogg",
		},
		["Moonkin Form"] = {
			[1] = "Sound\\Creature\\ForceofNature\\ForceofNatureAttack.ogg",
			[2] = "Sound\\Creature\\ForceofNature\\ForceofNatureAttackB.ogg",
			[3] = "Sound\\Creature\\ForceofNature\\ForceofNatureAttackC.ogg",
			["Aggro"] = "Sound\\Creature\\ForceofNature\\ForceofNatureAggro.ogg",
		},
		["Orca Form"] = {
			[1] = "Sound\\Creature\\Orca\\OrcaAttackA.ogg",
			[2] = "Sound\\Creature\\Orca\\OrcaAttackB.ogg",
			[3] = "Sound\\Creature\\Orca\\OrcaAttackC.ogg",
			[4] = "Sound\\Creature\\Orca\\OrcaPreAggro.ogg",
			["Aggro"] = "Sound\\Creature\\Orca\\OrcaAggro.ogg",
		},
		["Spectral Wolf"] = {
			[1] = "Sound\\Creature\\Wolf_Ghost\\GhostWolfAttackA.ogg",
			[2] = "Sound\\Creature\\Wolf_Ghost\\GhostWolfAttackB.ogg",
			[3] = "Sound\\Creature\\Wolf_Ghost\\GhostWolfAttackC.ogg",
			[4] = "Sound\\Creature\\Wolf_Ghost\\GhostWolfAttackD.ogg",
			[5] = "Sound\\Creature\\Wolf_Ghost\\GhostWolfAttackE.ogg",
			[6] = "Sound\\Creature\\Wolf_Ghost\\GhostWolfAttackF.ogg",
			["Aggro"] = "Sound\\Creature\\Wolf_Ghost\\GhostWolfAggro3.ogg",
		},
		["Travel Form"] = {
			[1] = "Sound\\Creature\\Giraffe\\GiraffeAttackA.ogg",
			[2] = "Sound\\Creature\\Giraffe\\GiraffeAttackB.ogg",
			[3] = "Sound\\Creature\\Giraffe\\GiraffeAttackC.ogg",
			[4] = "Sound\\Creature\\Giraffe\\GiraffePreAggroA.ogg",
			["Aggro"] = "Sound\\Creature\\Giraffe\\GiraffeAggroA.ogg",
		},
		["Treant Form"] = {
			[1] = "Sound\\Creature\\Ent\\EntAttackA.ogg",
			[2] = "Sound\\Creature\\Ent\\EntAttackB.ogg",
			[3] = "Sound\\Creature\\Ent\\EntAttackC.ogg",
			[4] = "Sound\\Creature\\Ent\\EntAttackD.ogg",
			["Aggro"] = "Sound\\Creature\\Ent\\EntAggroA.ogg",
		},
	};
end

function WanWan_CheckGlyphs()
	WanWan.GlyphEnabled_Orca, WanWan.GlyphEnabled_Cheetah, WanWan.GlyphEnabled_Stars, WanWan.GlyphEnabled_Spectral = false, false, false, false;
	for i = 1, NUM_GLYPH_SLOTS do
		local Enabled, SpellID = select(1, GetGlyphSocketInfo(i)), select(4, GetGlyphSocketInfo(i));
		local Name = select(1, GetSpellInfo(SpellID));
		if(Name == "Glyph of the Orca") then
			WanWan.GlyphEnabled_Orca = true;
		elseif(Name == "Glyph of the Cheetah") then
			WanWan.GlyphEnabled_Cheetah = true;
		elseif(Name == "Glyph of Stars") then
			WanWan.GlyphEnabled_Stars = true;
		elseif(Name == "Glyph of the Spectral Wolf") then
			WanWan.GlyphEnabled_Spectral = true;
		end
	end
	WanWan.GlyphsChecked = true;
end

function WanWan_Help()
	print("|cff22b14cWan-Wan!|r slash commands:");
	print("\"|cff22b14c/wanwan|r\" --> Toggle the extra sounds made in feral form on or off");
	print("\"|cff22b14c/wanwan spam|r\" --> Toggle the login greeting on or off");
	print("\"|cff22b14c/wanwan reset|r\" --> Reset the settings for |cff22b14cWan-Wan!|r");
	print("\"|cff22b14c/wanwan x|r\" --> Adjust how long (in seconds) you want the addon to wait when making extra sounds (x must be an integer between 1 and 20, inclusive)");
	print("\"|cff22b14c/wanwan ?|r\" --> Display these messages");
	print("NOTE: You can always use |cff22b14c\"/bowwow\"|r instead.");
end

function WanWan_Menu(msg)
	if(msg == "") then
		-- No message, technically. Toggle the WanWan.Options.Enabled variable.
		WanWan_Toggle();
	elseif((strlower(msg) == "spam") or (strlower(msg) == "s")) then
		-- 'spam' message. Toggle the login spam message.
		WanWan_SpamToggle();
	elseif((msg == "?") or (strlower(msg) == "help") or (strlower(msg) == "h")) then
		-- '?' or 'help' message. Spam the different slash command options.
		WanWan_Help();
	elseif((strlower(msg) == "reset") or (strlower(msg) == "r")) then
		-- 'reset' message. Reset the settings for the WanWan.Options table variable.
		WanWan_Reset();
	else
		-- Number message. Use it to set the WanWan.Options.Count_Max variable, if valid.
		WanWan_SetCountMax(tonumber(msg));
	end
end

function WanWan_OnDragStart(self)
	self:StartMoving();
end

function WanWan_OnDragStop(self)
	self:StopMovingOrSizing();
end

function WanWan_OnEvent(self, event, ...)
	if(event == "ADDON_LOADED") then
		arg1 = ...;
		if(arg1 == "WanWan") then
			if(WanWan_Save) then
				WanWan.Options = WanWan_Save;
			else
				WanWan.Options = WanWan.Defaults;
			end
			if(WanWan.Options.Spam) then
				print("|cff22b14cWan-Wan!|r has been successfully loaded! Type \"|cff22b14c/wanwan ?|r\" or \"|cff22b14c/bowwow ?|r\" for a list of acceptable commands.");
			end
		end
	elseif(event == "PLAYER_LOGOUT") then
		WanWan_Save = WanWan.Options;
	elseif(event == "GLYPH_UPDATED") then
		WanWan_CheckGlyphs();
	else
		local class, race = select(2, UnitClass("player")), select(2, UnitRace("player"));
		if((WanWan.Options.Enabled) and ((class == "DRUID") or (class == "SHAMAN"))) then
			if(not WanWan.GlyphsChecked) then
				WanWan_CheckGlyphs();
			end
			if((WanWan.IsBattleReady) and (event == "PLAYER_ENTER_COMBAT")) then
				if(UnitBuff("player", "Aquatic Form")) then
					if(WanWan.GlyphEnabled_Orca) then
						PlaySoundFile(WanWan_Sounds["Orca Form"]["Aggro"]);
					else
						PlaySoundFile(WanWan_Sounds["Aquatic Form"]["Aggro"]);
					end
				elseif(UnitBuff("player", "Bear Form")) then
					PlaySoundFile(WanWan_Sounds["Bear Form"]["Aggro"]);
				elseif(UnitBuff("player", "Cat Form")) then
					PlaySoundFile(WanWan_Sounds["Cat Form"]["Aggro"]);
				elseif(UnitBuff("player", "Ghost Wolf")) then
					if(WanWan.GlyphEnabled_Spectral) then
						PlaySoundFile(WanWan_Sounds["Spectral Wolf"]["Aggro"]);
					else
						PlaySoundFile(WanWan_Sounds["Ghost Wolf"]["Aggro"]);
					end
				elseif((UnitBuff("player", "Moonkin Form")) and (not WanWan.GlyphEnabled_Stars)) then
					PlaySoundFile(WanWan_Sounds["Moonkin Form"]["Aggro"]);
				elseif(UnitBuff("player", "Travel Form")) then
					if(WanWan.GlyphEnabled_Cheetah) then
						PlaySoundFile(WanWan_Sounds["Cat Form"]["Aggro"]);
					else
						PlaySoundFile(WanWan_Sounds["Travel Form"]["Aggro"]);
					end
				elseif((UnitBuff("player", "Treant Form") or (UnitBuff("player", "Incarnation: Tree of Life")))) then
					PlaySoundFile(WanWan_Sounds["Treant Form"]["Aggro"]);
				end
				WanWan.IsBattleReady = false;
				WanWan.BattleCount = 1;
			elseif(event == "PLAYER_REGEN_ENABLED") then
				WanWan.IsBattleReady = true;
				WanWan.BattleCount = nil;
			else
				if((WanWan.IsReady) and (tContains(WanWan.Events, event))) then
					if(UnitBuff("player", "Aquatic Form")) then
						x = math.random(1, 4);
						if(WanWan.GlyphEnabled_Orca) then
							PlaySoundFile(WanWan_Sounds["Orca Form"][x]);
						else
							PlaySoundFile(WanWan_Sounds["Aquatic Form"][x]);
						end
					elseif(UnitBuff("player", "Bear Form")) then
						x = math.random(1, 4);
						PlaySoundFile(WanWan_Sounds["Bear Form"][x]);
					elseif(UnitBuff("player", "Cat Form")) then
						x = math.random(1, 4);
						PlaySoundFile(WanWan_Sounds["Cat Form"][x]);
					elseif(UnitBuff("player", "Ghost Wolf")) then
						x = math.random(1, 6);
						if(WanWan.GlyphEnabled_Spectral) then
							PlaySoundFile(WanWan_Sounds["Spectral Wolf"][x]);
						else
							PlaySoundFile(WanWan_Sounds["Ghost Wolf"][x]);
						end
					elseif((UnitBuff("player", "Moonkin Form")) and (not WanWan.GlyphEnabled_Stars)) then
						x = math.random(1, 3);
						PlaySoundFile(WanWan_Sounds["Moonkin Form"][x]);
					elseif(UnitBuff("player", "Travel Form")) then
						x = math.random(1, 4);
						if(WanWan.GlyphEnabled_Cheetah) then
							PlaySoundFile(WanWan_Sounds["Cat Form"][x]);
						else
							PlaySoundFile(WanWan_Sounds["Travel Form"][x]);
						end
					elseif((UnitBuff("player", "Treant Form") or (UnitBuff("player", "Incarnation: Tree of Life")))) then
						x = math.random(1, 4);
						PlaySoundFile(WanWan_Sounds["Treant Form"][x]);
					elseif((UnitBuff("player", "Flight Form")) or (UnitBuff("player", "Swift Flight Form"))) then
						x = math.random(1, 4);
						if(race == "Troll") then
							PlaySoundFile(WanWan_Sounds["Bat Form"][x]);
						else
							PlaySoundFile(WanWan_Sounds["Flight Form"][x]);
						end
					end
					WanWan.IsReady = false;
					WanWan.Count = 1;
				end
			end
		end
	end
end

function WanWan_OnUpdate(self, elapsed)
	if(WanWan.Count) then
		-- Watching the regular count...
		WanWan.TimeSinceLastUpdate = WanWan.TimeSinceLastUpdate + elapsed;
		while((not WanWan.IsReady) and (WanWan.TimeSinceLastUpdate > WanWan.UpdateInterval)) do
			WanWan.Count = WanWan.Count + 1;
			if(WanWan.Count >= WanWan.Options.Count_Max) then
				WanWan.IsReady = true;
				WanWan.Count = nil;
			end
			WanWan.TimeSinceLastUpdate = WanWan.TimeSinceLastUpdate - WanWan.UpdateInterval;
		end
	elseif(WanWan.BattleCount) then
		-- Watching the combat count...
		WanWan.TimeSinceLastUpdate = WanWan.TimeSinceLastUpdate + elapsed;
		while((not WanWan.IsBattleReady) and (WanWan.TimeSinceLastUpdate > WanWan.UpdateInterval)) do
			WanWan.BattleCount = WanWan.BattleCount + 1;
			if(WanWan.BattleCount >= WanWan.Options.Count_Max) then
				WanWan.IsBattleReady = true;
				WanWan.BattleCount = nil;
			end
			WanWan.TimeSinceLastUpdate = WanWan.TimeSinceLastUpdate - WanWan.UpdateInterval;
		end
	end
end

function WanWan_Reset()
	WanWan.Options = {
		Count_Max = 5;
		Enabled  = true;
		Spam = true;
		Version = 3.2;
	};
	WanWan.IsReady = true;
	WanWan.IsBattleReady = true;
	WanWan.Count = nil;
	WanWan.BattleCount = nil;
	print("|cff22b14cWan-Wan!|r has been successfully reset!");
end

function WanWan_SetCountMax(x)
	-- The variable x must be an integer between 1 and 20, inclusive.
	if((x > 0) and (x <= 20)) then
		-- If x is a valid number as stated above, asign it to WanWan.Options.Count_Max.
		WanWan.Options.Count_Max = x;
		-- Let the user know that the option was successfully set.
		print("|cff22b14cWan-Wan!: WanWan.Options.Count_Max|r has been set to "..WanWan.Options.Count_Max.." seconds!");
	else
		-- Invalid number was used. Print an error message.
		print("|cff800000Error:|r When setting the |cff22b14cWanWan.Options.Count_Max|r variable, please use a valid integer between 1 and 20, inclusive.");
		print("If you need to see a list of acceptable commands, type \"|cff22b14c/wanwan ?|r\" or \"|cff22b14c/bowwow ?|r\"");
	end
end

function WanWan_SpamToggle()
	WanWan.Options.Spam = not WanWan.Options.Spam;
	if(WanWan.Options.Spam) then
		print("|cff22b14cWan-Wan!|r greeting has been |cff008000enabled|r.");
	else
		print("|cff22b14cWan-Wan!|r greeting has been |cff800000disabled|r.");
	end
end

function WanWan_Toggle()
	WanWan.Options.Enabled = not WanWan.Options.Enabled;
	if(WanWan.Options.Enabled) then
		WanWan.Count = nil;
		WanWan.BattleCount = nil;
		WanWan.IsReady = true;
		WanWan.IsBattleReady = true;
		print("|cff22b14cWan-Wan!|r is |cff008000enabled|r. You will make extra sounds in feral form.");
	else
		WanWan.Count = nil;
		WanWan.BattleCount = nil;
		WanWan.IsReady = false;
		WanWan.IsBattleReady = false;
		print("|cff22b14cWan-Wan!|r is |cff800000disabled|r. You will not make extra sounds in feral form.");
	end
end

--[[
	Special Thanks:
		- My family and friends for their support.
		- The WoW community (both in-game and in-forum) for their inspiration, advice, and support.
		- You, the addon user, for testing out my idea!
]]

--[[
	TODO:
		- [ ]Add Tree of Life form sounds
		- [ ]Add Treant form sounds
		- [ ]Add Spectral Ghost wolf form sounds
		- [ ]Add a simple GUI
		- [ ]Add a slash command to toggle the display of the GUI
		- [ ]Add User Interface sounds for the GUI
		- [ ]Add options for different sounds
		- [ ]Add enable/disable sound options
		- [ ]Put in more comments to further explain more of the code for curious users!!
]]
